searchData={"items":[{"type":"module","title":"Modbuzz","doc":"Documentation for `Modbuzz`.","ref":"Modbuzz.html"},{"type":"function","title":"Modbuzz.hello/0","doc":"Hello world.","ref":"Modbuzz.html#hello/0"},{"type":"function","title":"Examples - Modbuzz.hello/0","doc":"iex> Modbuzz.hello()\n    :world","ref":"Modbuzz.html#hello/0-examples"},{"type":"module","title":"Modbuzz.TCP.Client","doc":"This is MODBUS TCP client `GenServer` module.","ref":"Modbuzz.TCP.Client.html"},{"type":"function","title":"Modbuzz.TCP.Client.call/4","doc":"Makes a synchronous call to the server and waits for a response.\nOnly available when active: false.\n\nThe response type is `{:ok, %Res{}}` or `{:error, %Err{} | reason :: term()}`.","ref":"Modbuzz.TCP.Client.html#call/4"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.call/4","doc":"iex> alias Modbuzz.PDU.{WriteSingleCoil, ReadCoils}\n    [Modbuzz.PDU.WriteSingleCoil, Modbuzz.PDU.ReadCoils]\n    iex> Modbuzz.TCP.Client.call(%WriteSingleCoil.Req{output_address: 0 , output_value: true})\n    {:ok, %WriteSingleCoil.Res{output_address: 0 , output_value: true}}\n    iex> Modbuzz.TCP.Client.call(%ReadCoils.Req{starting_address: 0 , quantity_of_coils: 1})\n    {:ok, %ReadCoils.Res{byte_count: 1, [true, false, false, false, false, false, false, false]}}","ref":"Modbuzz.TCP.Client.html#call/4-examples"},{"type":"function","title":"Modbuzz.TCP.Client.cast/4","doc":"Casts a request to the server without waiting for a response.\nOnly available when active: true.\n\nThis function always returns :ok regardless of whether the destination server (or node) exists.\nTherefore it is unknown whether the destination server successfully handled the request.\n\nIts response is sent as a meessage, looks like\n\n```\n{:modbuzz, unit_id, request, response}\n```\n\nThe response type is `{:ok, %Res{}}` or `{:error, %Err{} | reason :: term()}`.","ref":"Modbuzz.TCP.Client.html#cast/4"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.cast/4","doc":"iex> alias Modbuzz.PDU.{WriteSingleCoil.Req, ReadCoils.Req}\n    [Modbuzz.PDU.WriteSingleCoil.Req, Modbuzz.PDU.ReadCoils.Req]\n    iex> Modbuzz.TCP.Client.cast(%WriteSingleCoil.Req{output_address: 0 , output_value: true})\n    :ok\n    iex> Modbuzz.TCP.Client.cast(%ReadCoils.Req{starting_address: 0 , quantity_of_coils: 1})\n    :ok","ref":"Modbuzz.TCP.Client.html#cast/4-examples"},{"type":"function","title":"Modbuzz.TCP.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbuzz.TCP.Client.html#child_spec/1"},{"type":"function","title":"Modbuzz.TCP.Client.start_link/1","doc":"Starts a Elixir.Modbuzz.TCP.Client GenServer process linked to the current process.","ref":"Modbuzz.TCP.Client.html#start_link/1"},{"type":"function","title":"Options - Modbuzz.TCP.Client.start_link/1","doc":"* `:name` - used for name registration as described in the \"Name\n    registration\" section in the documentation for `GenServer`\n\n  * `:address` - passed through to `:gen_tcp.connect/4`\n\n  * `:port` - passed through to `:gen_tcp.connect/4`\n\n  * `:active` - passed through to `:gen_tcp.connect/4`","ref":"Modbuzz.TCP.Client.html#start_link/1-options"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.start_link/1","doc":"iex> Modbuzz.TCP.Client.start_link([address: {192, 168, 0, 123}, port: 502, active: false])","ref":"Modbuzz.TCP.Client.html#start_link/1-examples"},{"type":"behaviour","title":"Modbuzz.TCP.TransportBehaviour","doc":"This behaviour provides the exact same interface as :gen_tcp.\n\nWe use `identifier()` as socket type for unit tests.","ref":"Modbuzz.TCP.TransportBehaviour.html"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.close/1","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:close/1"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.connect/4","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:connect/4"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.recv/3","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:recv/3"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.send/2","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:send/2"},{"type":"protocol","title":"Modbuzz.PDU.Protocol","doc":"Protocol for `MODBUS PDU`\n\nWe defined Req/Res/Err structs for each `MODBUS function`.\nEach struct implements this protocol.","ref":"Modbuzz.PDU.Protocol.html"},{"type":"type","title":"Modbuzz.PDU.Protocol.t/0","doc":"All the types that implement this protocol.","ref":"Modbuzz.PDU.Protocol.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadCoils.Err","doc":"Err struct for ReadCoils.","ref":"Modbuzz.PDU.ReadCoils.Err.html"},{"type":"type","title":"Modbuzz.PDU.ReadCoils.Err.t/0","doc":"","ref":"Modbuzz.PDU.ReadCoils.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadCoils.Req","doc":"Req struct for ReadCoils.","ref":"Modbuzz.PDU.ReadCoils.Req.html"},{"type":"type","title":"Modbuzz.PDU.ReadCoils.Req.t/0","doc":"","ref":"Modbuzz.PDU.ReadCoils.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadCoils.Res","doc":"Res struct for ReadCoils.","ref":"Modbuzz.PDU.ReadCoils.Res.html"},{"type":"type","title":"Modbuzz.PDU.ReadCoils.Res.t/0","doc":"","ref":"Modbuzz.PDU.ReadCoils.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadDiscreteInputs.Err","doc":"Err struct for ReadDiscreteInputs.","ref":"Modbuzz.PDU.ReadDiscreteInputs.Err.html"},{"type":"type","title":"Modbuzz.PDU.ReadDiscreteInputs.Err.t/0","doc":"","ref":"Modbuzz.PDU.ReadDiscreteInputs.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadDiscreteInputs.Req","doc":"Req struct for ReadDiscreteInputs.","ref":"Modbuzz.PDU.ReadDiscreteInputs.Req.html"},{"type":"type","title":"Modbuzz.PDU.ReadDiscreteInputs.Req.t/0","doc":"","ref":"Modbuzz.PDU.ReadDiscreteInputs.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadDiscreteInputs.Res","doc":"Res struct for ReadDiscreteInputs.","ref":"Modbuzz.PDU.ReadDiscreteInputs.Res.html"},{"type":"type","title":"Modbuzz.PDU.ReadDiscreteInputs.Res.t/0","doc":"","ref":"Modbuzz.PDU.ReadDiscreteInputs.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadHoldingRegisters.Err","doc":"Err struct for ReadHoldingRegisters.","ref":"Modbuzz.PDU.ReadHoldingRegisters.Err.html"},{"type":"type","title":"Modbuzz.PDU.ReadHoldingRegisters.Err.t/0","doc":"","ref":"Modbuzz.PDU.ReadHoldingRegisters.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadHoldingRegisters.Req","doc":"Req struct for ReadHoldingRegisters.","ref":"Modbuzz.PDU.ReadHoldingRegisters.Req.html"},{"type":"type","title":"Modbuzz.PDU.ReadHoldingRegisters.Req.t/0","doc":"","ref":"Modbuzz.PDU.ReadHoldingRegisters.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadHoldingRegisters.Res","doc":"Res struct for ReadHoldingRegisters.","ref":"Modbuzz.PDU.ReadHoldingRegisters.Res.html"},{"type":"type","title":"Modbuzz.PDU.ReadHoldingRegisters.Res.t/0","doc":"","ref":"Modbuzz.PDU.ReadHoldingRegisters.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadInputRegisters.Err","doc":"Err struct for ReadInputRegisters.","ref":"Modbuzz.PDU.ReadInputRegisters.Err.html"},{"type":"type","title":"Modbuzz.PDU.ReadInputRegisters.Err.t/0","doc":"","ref":"Modbuzz.PDU.ReadInputRegisters.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadInputRegisters.Req","doc":"Req struct for ReadInputRegisters.","ref":"Modbuzz.PDU.ReadInputRegisters.Req.html"},{"type":"type","title":"Modbuzz.PDU.ReadInputRegisters.Req.t/0","doc":"","ref":"Modbuzz.PDU.ReadInputRegisters.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadInputRegisters.Res","doc":"Res struct for ReadInputRegisters.","ref":"Modbuzz.PDU.ReadInputRegisters.Res.html"},{"type":"type","title":"Modbuzz.PDU.ReadInputRegisters.Res.t/0","doc":"","ref":"Modbuzz.PDU.ReadInputRegisters.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleCoils.Err","doc":"Err struct for WriteMultipleCoils.","ref":"Modbuzz.PDU.WriteMultipleCoils.Err.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleCoils.Err.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleCoils.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleCoils.Req","doc":"Req struct for WriteMultipleCoils.","ref":"Modbuzz.PDU.WriteMultipleCoils.Req.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleCoils.Req.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleCoils.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleCoils.Res","doc":"Res struct for WriteMultipleCoils.","ref":"Modbuzz.PDU.WriteMultipleCoils.Res.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleCoils.Res.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleCoils.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleRegisters.Err","doc":"Err struct for WriteMultipleRegisters.","ref":"Modbuzz.PDU.WriteMultipleRegisters.Err.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleRegisters.Err.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleRegisters.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleRegisters.Req","doc":"Req struct for WriteMultipleRegisters.","ref":"Modbuzz.PDU.WriteMultipleRegisters.Req.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleRegisters.Req.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleRegisters.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteMultipleRegisters.Res","doc":"Res struct for WriteMultipleRegisters.","ref":"Modbuzz.PDU.WriteMultipleRegisters.Res.html"},{"type":"type","title":"Modbuzz.PDU.WriteMultipleRegisters.Res.t/0","doc":"","ref":"Modbuzz.PDU.WriteMultipleRegisters.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleCoil.Err","doc":"Err struct for WriteSingleCoil.","ref":"Modbuzz.PDU.WriteSingleCoil.Err.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleCoil.Err.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleCoil.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleCoil.Req","doc":"Req struct for WriteSingleCoil.","ref":"Modbuzz.PDU.WriteSingleCoil.Req.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleCoil.Req.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleCoil.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleCoil.Res","doc":"Res struct for WriteSingleCoil.","ref":"Modbuzz.PDU.WriteSingleCoil.Res.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleCoil.Res.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleCoil.Res.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleRegister.Err","doc":"Err struct for WriteSingleRegister.","ref":"Modbuzz.PDU.WriteSingleRegister.Err.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleRegister.Err.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleRegister.Err.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleRegister.Req","doc":"Req struct for WriteSingleRegister.","ref":"Modbuzz.PDU.WriteSingleRegister.Req.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleRegister.Req.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleRegister.Req.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleRegister.Res","doc":"Res struct for WriteSingleRegister.","ref":"Modbuzz.PDU.WriteSingleRegister.Res.html"},{"type":"type","title":"Modbuzz.PDU.WriteSingleRegister.Res.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleRegister.Res.html#t:t/0"},{"type":"extras","title":"Modbuzz","doc":"# Modbuzz\n\n[![hex](https://img.shields.io/hexpm/v/modbuzz.svg)](https://hex.pm/packages/modbuzz)\n[![CI](https://github.com/tombo-works/modbuzz/actions/workflows/ci.yaml/badge.svg)](https://github.com/tombo-works/modbuzz/actions/workflows/ci.yaml)\n[![license](https://img.shields.io/hexpm/l/modbuzz.svg)](https://github.com/tombo-works/modbuzz/blob/main/REUSE.toml)\n[![REUSE](https://api.reuse.software/badge/github.com/tombo-works/modbuzz)](https://api.reuse.software/info/github.com/tombo-works/modbuzz)\n\nYet another MODBUS TCP library.","ref":"readme.html"},{"type":"extras","title":"MODBUS References - Modbuzz","doc":"- WEB: https://modbus.org/\n  - PDF: [MODBUS APPLICATION PROTOCOL SPECIFICATION V1.1b3](https://modbus.org/docs/Modbus_Application_Protocol_V1_1b3.pdf)\n  - PDF: [MODBUS MESSAGING ON TCP/IP IMPLEMENTATION GUIDE V1.0b](https://modbus.org/docs/Modbus_Messaging_Implementation_Guide_V1_0b.pdf)","ref":"readme.html#modbus-references"},{"type":"extras","title":"Installation - Modbuzz","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `modbuzz` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:modbuzz, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"License - Modbuzz","doc":"This project is licensed under the Apache-2.0 license.\n\nAnd this project follows the REUSE compliance.\nFor more details, see the [REUSE SOFTWARE](https://reuse.software/).","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}